function remote_init()
	local items={
		{name="Keyboard", input="keyboard"},
		{name="Channel Pressure", input="value", min=0, max=127},
		{name="Mod Wheel", input="value", min=0, max=127},
		{name="Pitch Bend", input="value", min=0, max=16384},
		{name="Expression", input="value", min=0, max=127},
		{name="Damper Pedal", input="value", min=0, max=127},

		{name="Knob 1", input="value", min=0, max=127},
		{name="Knob 2", input="value", min=0, max=127},
		{name="Knob 3", input="value", min=0, max=127},
		{name="Knob 4", input="value", min=0, max=127},
		{name="Knob 5", input="value", min=0, max=127},
		{name="Knob 6", input="value", min=0, max=127},
		{name="Knob 7", input="value", min=0, max=127},
		{name="Knob 8", input="value", min=0, max=127},
		{name="Knob 9", input="value", min=0, max=127},
		{name="Knob 10", input="value", min=0, max=127},
		{name="Knob 11", input="value", min=0, max=127},
		{name="Knob 12", input="value", min=0, max=127},

		{name="Knob 13", input="value", min=0, max=127},
		{name="Knob 14", input="value", min=0, max=127},
		{name="Knob 15", input="value", min=0, max=127},
		{name="Knob 16", input="value", min=0, max=127},
		{name="Knob 17", input="value", min=0, max=127},
		{name="Knob 18", input="value", min=0, max=127},
		{name="Knob 19", input="value", min=0, max=127},
		{name="Knob 20", input="value", min=0, max=127},
		{name="Knob 21", input="value", min=0, max=127},
		{name="Knob 22", input="value", min=0, max=127},
		{name="Knob 23", input="value", min=0, max=127},
		{name="Knob 24", input="value", min=0, max=127},
				
		{name="Switch 1", input="value", min=0, max=127},
		{name="Switch 2", input="value", min=0, max=127},
		{name="Switch 3", input="value", min=0, max=127},
		{name="Switch 4", input="value", min=0, max=127},

		{name="Switch 5", input="value", min=0, max=127},
		{name="Switch 6", input="value", min=0, max=127},
		{name="Switch 7", input="value", min=0, max=127},
		{name="Switch 8", input="value", min=0, max=127},
		
		{name="Pad D1", input="button"},
		{name="Pad D2", input="button"},
		{name="Pad D3", input="button"},
		{name="Pad D4", input="button"},
		{name="Pad D5", input="button"},
		{name="Pad D6", input="button"},
		{name="Pad D7", input="button"},
		{name="Pad D8", input="button"},
		{name="Pad D9", input="button"},
		{name="Pad D10", input="button"},
		{name="Pad D11", input="button"},
		{name="Pad D12", input="button"},

		{name="Rewind", input="button"},
		{name="Fast Forward", input="button"},
		{name="Stop", input="button"},
		{name="Play", input="button"},
		{name="Record", input="button"},

			}
	remote.define_items(items)

	local inputs={

		{pattern="b0 03 xx", name="Knob 1"},
		{pattern="b0 04 xx", name="Knob 2"},
		{pattern="b0 05 xx", name="Knob 3"},
		{pattern="b0 06 xx", name="Knob 4"},
		{pattern="b0 08 xx", name="Knob 5"},
		{pattern="b0 09 xx", name="Knob 6"},
		{pattern="b0 0C xx", name="Knob 7"},
		{pattern="b0 0D xx", name="Knob 8"},
		{pattern="b0 0E xx", name="Knob 9"},
		{pattern="b0 0F xx", name="Knob 10"},
		{pattern="b0 10 xx", name="Knob 11"},
		{pattern="b0 11 xx", name="Knob 12"},

		{pattern="b1 03 xx", name="Knob 13"},
		{pattern="b1 04 xx", name="Knob 14"},
		{pattern="b1 05 xx", name="Knob 15"},
		{pattern="b1 06 xx", name="Knob 16"},	
		{pattern="b1 08 xx", name="Knob 17"},
		{pattern="b1 09 xx", name="Knob 18"},
		{pattern="b1 0C xx", name="Knob 19"},
		{pattern="b1 0D xx", name="Knob 20"},
		{pattern="b1 0E xx", name="Knob 21"},
		{pattern="b1 0F xx", name="Knob 22"},
		{pattern="b1 10 xx", name="Knob 23"},
		{pattern="b1 11 xx", name="Knob 24"},

		{pattern="b0 12 xx", name="Switch 1"},
		{pattern="b0 13 xx", name="Switch 2"},
		{pattern="b0 14 xx", name="Switch 3"},
		{pattern="b0 15 xx", name="Switch 4"},

		{pattern="b1 12 xx", name="Switch 5"},
		{pattern="b1 13 xx", name="Switch 6"},
		{pattern="b1 14 xx", name="Switch 7"},
		{pattern="b1 15 xx", name="Switch 8"},

		{pattern="CF 00", name="Pad D1", value="1"},
		{pattern="CF 01", name="Pad D2", value="1"},
		{pattern="CF 02", name="Pad D3", value="1"},
		{pattern="CF 03", name="Pad D4", value="1"},
		{pattern="CF 04", name="Pad D5", value="1"},
		{pattern="CF 05", name="Pad D6", value="1"},
		{pattern="CF 06", name="Pad D7", value="1"},
		{pattern="CF 07", name="Pad D8", value="1"},
		{pattern="CF 08", name="Pad D9", value="1"},
		{pattern="CF 09", name="Pad D10", value="1"},
		{pattern="CF 0A", name="Pad D11", value="1"},
		{pattern="CF 0B", name="Pad D12", value="1"},

		{pattern="e? xx yy", name="Pitch Bend", value="y*128 + x"},
		{pattern="b0 01 xx", name="Mod Wheel"},
		{pattern="b0 0b xx", name="Expression"},
		{pattern="b0 40 xx", name="Damper Pedal"},
		{pattern="d0 xx", name="Channel Pressure"},

		{pattern="80 xx yy", name="Keyboard", value="0", note="x", velocity="64"},
		
		{pattern="90 xx 00", name="Keyboard", value="0", note="x", velocity="64"},
		{pattern="<100x>0 yy zz", name="Keyboard"},

		{pattern="F0 7F 7F 06 05 F7", name="Rewind", value="1"},
		{pattern="F0 7F 7F 06 04 F7", name="Fast Forward", value="1"},
		{pattern="F0 7F 7F 06 01 F7", name="Stop", value="1"},
		{pattern="F0 7F 7F 06 02 F7", name="Play", value="1"},
		{pattern="F0 7F 7F 06 06 F7", name="Record", value="1"},


	}
	remote.define_auto_inputs(inputs)
end


function remote_probe()

	local controlRequest="F0 7E 7F 06 01 F7"

	local controlResponse="F0 7E 00 06 02 47 72 00 19 00 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? F7"
return {
		request=controlRequest,
		response=controlResponse
	}
end

